'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _plugins = require('./plugins');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var hash, compress, plugins, dll, ENV, filename, chunkFilename, cwd, outputPath, _context$records, records, _context$aggressive, aggressive, _context$analyzer, analyzer;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.plugins = [new _plugins.FriendlyErrorsWebpackPlugin({
              onErrors: function onErrors(severity, errors) {
                if (severity !== 'error') {
                  _util.notifier.notify({
                    title: 'hollow cli',
                    message: 'warn',
                    contentImage: _path2.default.join(__dirname, '../assets/warn.png'),
                    sound: 'Glass'
                  });
                  return;
                }
                var error = errors[0];
                _util.notifier.notify({
                  title: 'hollow cli',
                  message: severity + ' : ' + (error ? error.name : error),
                  subtitle: error ? error.file : error || '',
                  contentImage: _path2.default.join(__dirname, '../assets/fail.png'),
                  sound: 'Glass'
                });
              }
            }), new _plugins.ProgressPlugin(_util.fnProgressHandler), new _plugins.HashedModuleIdsPlugin()];

            next();

            hash = context.hash, compress = context.compress, plugins = context.plugins, dll = context.dll, ENV = context.ENV;


            if (!Array.isArray(dll)) {
              context.webpackConfig.optimization.splitChunks = {
                chunks: 'all',
                minSize: 100,
                minChunks: 1,
                maxAsyncRequests: 6,
                maxInitialRequests: 3,
                name: !ENV.isProduction,
                cacheGroups: {
                  styles: {
                    name: 'styles',
                    test: /\.css$/,
                    chunks: 'all',
                    enforce: true
                  },
                  vendors: {
                    test: /[\\/]node_modules[\\/]/,
                    name: 'dependencies',
                    priority: -100,
                    reuseExistingChunk: true,
                    chunks: 'all'
                  },
                  default: false
                }
              };
            }

            filename = hash ? '[name]-[hash].css' : '[name].css';
            chunkFilename = hash ? '[id]-[hash].css' : '[id].css';


            plugins.push(new _plugins.MiniCssExtractPlugin({ filename: filename, chunkFilename: chunkFilename }));

            context.webpackConfig.optimization.minimize = !!compress;

            if (compress) {
              context.webpackConfig.optimization.minimizer = [new _plugins.UglifyJsPlugin({
                cache: true,
                parallel: true,
                sourceMap: false
              }), new _plugins.OptimizeCSSAssetsPlugin({})];
            }

            cwd = context.cwd, outputPath = context.outputPath, _context$records = context.records, records = _context$records === undefined ? false : _context$records, _context$aggressive = context.aggressive, aggressive = _context$aggressive === undefined ? true : _context$aggressive, _context$analyzer = context.analyzer, analyzer = _context$analyzer === undefined ? false : _context$analyzer;

            // dll 模式下不能使用当前插件

            if (!Array.isArray(dll) && aggressive === true) {
              plugins.push(new _plugins.AggressiveSplittingPlugin((0, _util.getOptions)(aggressive, {
                minSize: 1,
                maxSize: 1024 * 1024,
                chunkOverhead: 0,
                entryChunkMultiplicator: 1
              })));
            }

            // plugins.push(new HardSourceWebpackPlugin())

            context.plugins = plugins;

            if (records) {
              context.webpackConfig.recordsOutputPath = _path2.default.join(cwd, outputPath, (0, _util.getOptions)(records, 'records.json'));
            }

            if (analyzer) {
              plugins.push(new _plugins.BundleAnalyzerPlugin((0, _util.getOptions)(analyzer)));
            }

          case 14:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function mwPlugins(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return mwPlugins;
}(); /**************************************************
      * Created by nanyuantingfeng on 27/10/2017 16:25.
      **************************************************/


module.exports = exports['default'];