'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _plugins = require('./plugins');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function fnGetThemeMap(packageMap, cwd) {
  var theme = {};

  var packageMapTheme = packageMap.theme;

  if (packageMapTheme && typeof packageMapTheme === 'string') {
    var pp = packageMapTheme;

    if (pp.charAt(0) === '.') {
      pp = _path2.default.resolve(cwd, pp);
    }

    var fn = require(pp);
    theme = fn();
  } else if (packageMapTheme && (typeof packageMapTheme === 'undefined' ? 'undefined' : (0, _typeof3.default)(packageMapTheme)) === 'object') {
    theme = packageMapTheme;
  }

  return theme;
} /**************************************************
   * Created by nanyuantingfeng on 27/10/2017 16:28.
   **************************************************/

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var cwd, _context$limit, limit, ENV, packageMap, hash, plugins, isNeedTSChecker, theme, postcssOptions, tsConfigPath, rules, workerFileName, _XSX_LOADER, JSX_LOADER, TSX_LOADER, scriptRules, stylesRules, othersRules, styleRulesFixed;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.rules = [];

            next();

            cwd = context.cwd, _context$limit = context.limit, limit = _context$limit === undefined ? 10000 : _context$limit, ENV = context.ENV, packageMap = context.packageMap, hash = context.hash, plugins = context.plugins, isNeedTSChecker = context.isNeedTSChecker;
            theme = fnGetThemeMap(packageMap, cwd);
            postcssOptions = context.postcssOptions, tsConfigPath = context.tsConfigPath, rules = context.rules;
            workerFileName = hash ? '[name]-[hash].worker.js' : '[name].worker.js';
            _XSX_LOADER = XSX_LOADER(context), JSX_LOADER = _XSX_LOADER.JSX_LOADER, TSX_LOADER = _XSX_LOADER.TSX_LOADER;
            scriptRules = [{
              test: /\.worker\.jsx?$/,
              exclude: /node_modules/,
              use: [{ loader: 'worker-loader', options: { name: workerFileName } }].concat((0, _toConsumableArray3.default)(JSX_LOADER))
            }, {
              test: function test(filePath) {
                return (/\.lazy\.jsx?$/.test(filePath)
                );
              },

              exclude: /node_modules/,
              use: [{ loader: 'bundle-loader', options: { lazy: true } }].concat((0, _toConsumableArray3.default)(JSX_LOADER))
            }, {
              test: function test(filePath) {
                return (/\.jsx?$/.test(filePath) && !/\.lazy\.jsx?$/.test(filePath) && !/\.worker\.jsx?$/.test(filePath)
                );
              },

              exclude: /node_modules/,
              use: JSX_LOADER
            }, {
              test: /\.tsx?$/,
              exclude: /node_modules/,
              use: TSX_LOADER
            }];
            stylesRules = [{
              test: function test(filePath) {
                return (/\.css$/.test(filePath) && !/\.module\.css$/.test(filePath)
                );
              },

              use: [{ loader: 'style-loader' }, {
                loader: 'css-loader',
                options: {
                  sourceMap: true
                }
              }, { loader: 'postcss-loader', options: postcssOptions }]
            }, {
              test: /\.module\.css$/,
              use: [{ loader: 'style-loader' }, {
                loader: 'css-loader',
                options: {
                  sourceMap: true,
                  modules: true,
                  localIdentName: '[local]___[hash:base64:5]'
                }
              }, { loader: 'postcss-loader', options: postcssOptions }]
            }, {
              test: function test(filePath) {
                return (/\.less$/.test(filePath) && !/\.module\.less$/.test(filePath)
                );
              },

              use: [{ loader: 'style-loader' }, {
                loader: 'css-loader',
                options: {
                  sourceMap: true
                }
              }, { loader: 'postcss-loader', options: postcssOptions }, {
                loader: 'less-loader',
                options: {
                  javascriptEnabled: true,
                  sourceMap: true,
                  modifyVars: theme
                }
              }]
            }, {
              test: /\.module\.less$/,
              use: [{ loader: 'style-loader' }, {
                loader: 'css-loader',
                options: {
                  sourceMap: true,
                  modules: true,
                  localIdentName: '[local]___[hash:base64:5]'
                }
              }, { loader: 'postcss-loader', options: postcssOptions }, {
                loader: 'less-loader',
                options: {
                  javascriptEnabled: true,
                  sourceMap: true,
                  modifyVars: theme
                }
              }]
            }];
            othersRules = [{
              test: /\.woff(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'application/font-woff' }
              }]
            }, {
              test: /\.woff2(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'application/font-woff' }
              }]
            }, {
              test: /\.ttf(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'application/octet-stream' }
              }]
            }, {
              test: /\.eot(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'application/vnd.ms-fontobject' }
              }]
            }, {
              test: /\.svg(\?v=\d+\.\d+\.\d+)?$/,
              use: [{
                loader: 'url-loader',
                options: { limit: limit, mimetype: 'image/svg+xml' }
              }]
            }, {
              test: /\.(png|jpg|jpeg|gif)(\?v=\d+\.\d+\.\d+)?$/i,
              use: [{ loader: 'url-loader', options: { limit: limit } }]
            }, {
              test: /\.html?$/,
              use: [{
                loader: 'file-loader',
                options: {
                  name: '[path]-[name].[ext]'
                }
              }]
            }, {
              test: /\.hbs?$/,
              use: [{ loader: 'mustache-loader' }]
            }];
            styleRulesFixed = stylesRules;


            if (ENV.isProduction || ENV.isBeta) {
              styleRulesFixed = stylesRules.map(function (rule) {
                rule.use[0] = _plugins.MiniCssExtractPlugin.loader;
                return rule;
              });
            }

            context.rules = scriptRules.concat(styleRulesFixed).concat(othersRules).concat(rules);

            if (isNeedTSChecker === true) {
              plugins.push(new _plugins.ForkTsCheckerWebpackPlugin({
                tsconfig: tsConfigPath,
                checkSyntacticErrors: true,
                colors: true,
                async: true
              }));

              plugins.push(new _plugins.WatchIgnorePlugin([/\.d\.ts$/]));
            }

          case 14:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

function XSX_LOADER(context) {
  var _context$enableHappyp = context.enableHappypack,
      enableHappypack = _context$enableHappyp === undefined ? true : _context$enableHappyp;

  return enableHappypack ? happypackL(context) : commonL(context);
}

function happypackL(context) {
  var commonX = commonL(context, true);

  var THREAD_POOL_CPU_SIZE = _os2.default.cpus().length / 2;

  var threadPool = _plugins.HappyPack.ThreadPool({ size: THREAD_POOL_CPU_SIZE });

  var plugins = context.plugins;


  plugins.push(new _plugins.HappyPack({
    id: 'jsx',
    threadPool: threadPool,
    loaders: commonX.JSX_LOADER
  }));

  plugins.push(new _plugins.HappyPack({
    id: 'tsx',
    threadPool: threadPool,
    loaders: commonX.TSX_LOADER
  }));

  var JSX_LOADER = [{ loader: 'happypack/loader', options: { id: 'jsx' } }];
  var TSX_LOADER = [{ loader: 'happypack/loader', options: { id: 'tsx' } }];

  return { JSX_LOADER: JSX_LOADER, TSX_LOADER: TSX_LOADER };
}

function commonL(context) {
  var happyPackMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var babelOptions = context.babelOptions,
      tsOptions = context.tsOptions;


  var JSX_LOADER = [{ loader: 'babel-loader', options: babelOptions }];

  var tsOptions2 = tsOptions;

  if (happyPackMode) {
    tsOptions2 = (0, _extends3.default)({ happyPackMode: true }, tsOptions);
  }

  var TSX_LOADER = [JSX_LOADER[0], { loader: 'ts-loader', options: tsOptions2 }];

  return { JSX_LOADER: JSX_LOADER, TSX_LOADER: TSX_LOADER };
}
module.exports = exports['default'];