'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/**************************************************
 * Created by nanyuantingfeng on 22/08/2017 21:57.
 **************************************************/
var noop = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function noop() {
    return _ref.apply(this, arguments);
  };
}();

exports.mwsBuild = mwsBuild;
exports.mwsDevServer = mwsDevServer;
exports.mwsDLL = mwsDLL;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _mwBuild = require('./mwBuild');

var _mwBuild2 = _interopRequireDefault(_mwBuild);

var _mwBabelOptions = require('./mwBabelOptions');

var _mwBabelOptions2 = _interopRequireDefault(_mwBabelOptions);

var _mwPostCSSOptions = require('./mwPostCSSOptions');

var _mwPostCSSOptions2 = _interopRequireDefault(_mwPostCSSOptions);

var _mwTSOptions = require('./mwTSOptions');

var _mwTSOptions2 = _interopRequireDefault(_mwTSOptions);

var _mwDevServer = require('./mwDevServer');

var _mwDevServer2 = _interopRequireDefault(_mwDevServer);

var _mwMultiEntryHTML = require('./mwMultiEntryHTML');

var _mwMultiEntryHTML2 = _interopRequireDefault(_mwMultiEntryHTML);

var _mwPlugins = require('./mwPlugins');

var _mwPlugins2 = _interopRequireDefault(_mwPlugins);

var _mwRules = require('./mwRules');

var _mwRules2 = _interopRequireDefault(_mwRules);

var _mwENV = require('./mwENV');

var _mwENV2 = _interopRequireDefault(_mwENV);

var _mwDLL = require('./mwDLL');

var _mwDLL2 = _interopRequireDefault(_mwDLL);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getCustomConfig(cwd, config) {
  var _paths, _paths2, _paths3;

  if ('function' === typeof config) {
    return config;
  }

  var paths = [];

  switch (process.env.NODE_ENV) {
    case 'production':
      (_paths = paths).push.apply(_paths, ['build', 'production', 'prod']);
      break;
    case 'development':
      (_paths2 = paths).push.apply(_paths2, ['development', 'develop', 'dev']);
      break;
    case 'beta':
      (_paths3 = paths).push.apply(_paths3, ['beta', 'build', 'production', 'prod', 'development', 'develop', 'dev']);
      break;
    default:
      paths.push(process.env.NODE_ENV);
      break;
  }

  paths.push('config');
  paths = paths.map(function (name) {
    return 'webpack.' + name + '.js';
  });

  config && paths.unshift(config);

  var cc = noop;
  var i = -1;
  while (++i < paths.length) {
    var p = paths[i];
    var pp = _path2.default.join(cwd, p);
    if (_fs2.default.existsSync(pp)) {
      console.log('>', pp);
      cc = require(pp);
      break;
    }
  }

  return cc;
}

function mwsBuild(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);

  return [_mwENV2.default, _mwBuild2.default, _mwMultiEntryHTML2.default, _mwDLL2.default, _mwPlugins2.default, _mwRules2.default, _mwBabelOptions2.default, _mwPostCSSOptions2.default, _mwTSOptions2.default, mwConfig];
}

function mwsDevServer(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);

  return [_mwENV2.default, _mwBuild2.default, _mwMultiEntryHTML2.default, _mwDLL2.default, _mwPlugins2.default, _mwRules2.default, _mwBabelOptions2.default, _mwPostCSSOptions2.default, _mwTSOptions2.default, _mwDevServer2.default, mwConfig];
}

function mwsDLL(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);
  return [_mwENV2.default, _mwBuild2.default, _mwDLL2.default, _mwPlugins2.default, _mwRules2.default, _mwBabelOptions2.default, _mwPostCSSOptions2.default, _mwTSOptions2.default, mwConfig];
}